package test.java.portlet;

import java.io.IOException;
import javax.portlet.ActionRequest;
import javax.portlet.ActionResponse;
import javax.portlet.GenericPortlet;
import javax.portlet.PortletException;
import javax.portlet.PortletRequest;
import javax.portlet.PortletURL;
import javax.portlet.RenderRequest;
import javax.portlet.RenderResponse;
import javax.portlet.ResourceRequest;
import javax.portlet.ResourceResponse;
import javax.servlet.http.Cookie;

/**
 * Copyright (c) 2000-2016 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */
/**
 * @author  Kyle Stiemann
 */
public class TestJavaPortlet extends GenericPortlet {

	@Override
	protected void doView(RenderRequest request, RenderResponse response) throws PortletException, IOException {
		
		response.setContentType("text/html");
		response.getWriter().append("test<br />");
		
		Cookie testCookie = new Cookie("testDoView", "testDoView");
		response.addProperty(testCookie);

		response.getWriter().append("<a href=\"");
		response.getWriter().append(response.createRenderURL().toString());
		response.getWriter().append("\">RenderURL</a><br />");

		response.getWriter().append("<form method=\"post\" action=\"");
		response.getWriter().append(response.createActionURL().toString());
		response.getWriter().append("\"><button type=\"submit\">ActionURL</button></form>");

		response.getWriter().append("<a href=\"");
		response.getWriter().append(response.createResourceURL().toString());
		response.getWriter().append("\">ResourceURL</a><br />");

		Cookie[] cookies = request.getCookies();

		if (cookies != null) {
			for (Cookie cookie : cookies) {

				if (cookie.getName().contains("test")) {
					response.getWriter().append("TestCookie :");
				}

				response.getWriter().append(cookie.getName() + " " + cookie.getValue() + " " + cookie + "<br />");
			}
		}
		else {
			response.getWriter().append("no cookies found<br />");
		}
	}

	@Override
	public void processAction(ActionRequest request, ActionResponse response) throws PortletException, IOException {

		Cookie testCookie = new Cookie("testProcessAction", "testProcessAction");
		response.addProperty(testCookie);

		Cookie[] cookies = request.getCookies();

		if (cookies != null) {
			for (Cookie cookie : cookies) {

				if (cookie.getName().contains("test")) {
					System.out.print("TestCookie :");
				}

				System.out.print(cookie.getName() + " " + cookie.getValue() + " " + cookie + "\n");
			}
		}
		else {
			System.out.print("no cookies found\n");
		}
	}

	@Override
	public void serveResource(ResourceRequest request, ResourceResponse response) throws PortletException, IOException {

		Cookie testCookie = new Cookie("testServeResource", "testServeResource");
		response.addProperty(testCookie);

		Cookie[] cookies = request.getCookies();

		if (cookies != null) {
			for (Cookie cookie : cookies) {

				if (cookie.getName().contains("test")) {
					System.out.print("TestCookie :");
				}

				System.out.print(cookie.getName() + " " + cookie.getValue() + " " + cookie + "\n");
			}
		}
		else {
			System.out.print("no cookies found\n");
		}
	}
}
